#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "dostart") {&dostart;}
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "ropps") {&rv_opperations;}
if ($q->param('fct') eq "save_reviews") {&save_reviews;}
if ($q->param('fct') eq "Delete") {&del_reviews;}
if ($q->param('fct') eq "set_results") {&set_results;}


sub set_results
{

$results_to_list = $q->param('results');
acs::update_setting("comments_nr", "$results_to_list");

&start;

}





sub dostart
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$found_col = "false";
$sth = $dbh->prepare("describe reviews");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
while ( @row = $sth->fetchrow() )
	{
	if ($row[0] =~ /tmprv/) { $found_col = "true"; }
	}

if ($found_col eq "false")
	{
	$sth = $dbh->prepare("ALTER TABLE reviews add tmprv int");
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	$sth = $dbh->prepare("ALTER TABLE reviews ADD INDEX (tmprv)");
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}			
	}


$sth = $dbh->prepare("SELECT count(*) FROM reviews");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
while ( @row = $sth->fetchrow() )
	{
	$total_reviews = $row[0];
	}


$sth = $dbh->prepare("SELECT count(*) FROM reviews AS A, links AS B where (A.lnkid = B.lnkid)");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
while ( @row = $sth->fetchrow() )
	{
	$total_reviews_with_links = $row[0];
	}

if ($total_reviews_with_links != $total_reviews)
	{

		$sth = $dbh->prepare("UPDATE reviews SET tmprv = '2'");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

		$sth = $dbh->prepare("UPDATE reviews,links SET reviews.tmprv = '1' WHERE (reviews.lnkid = links.lnkid)");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

		$sth = $dbh->prepare("DELETE FROM reviews WHERE tmprv = '2'");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	
	}


$sth->finish;
$dbh->disconnect;


&start;


}




sub del_reviews
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

for ($ms = 0; $ms < $q->param('enr'); $ms++)
	{
	$cname = "C" . $ms;
	if ($q->param($cname) ne "") 
		{
		($rvid, $lnkid, $review_nos) = split (/-/, $q->param($cname));
		$sql_wherer = $sql_wherer . " (rvid = '$rvid') OR";
		}
		
	}

$sql_wherer = substr($sql_wherer, 0, length($sql_wherer) - 2);

$sql = "DELETE FROM reviews WHERE $sql_wherer";

$sth = $dbh->prepare($sql);
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
$sth->execute;

$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_comment.gif", "Reviews/Comments Deleted", qq[
<a href="$admin_url/admin14.cgi">Click Here to Continue</a>
]);
 

print <<END_OF_RD;

<html>
<head>
<title>Reviews</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>

END_OF_RD

}



sub save_reviews
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = qq{UPDATE reviews SET  rname = ?,
								 		remail = ?,
										review = ?
										WHERE
										rvid = ?
			 };

$sth = $dbh->prepare($sql);
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

for ($ms = 0; $ms < $q->param('enr'); $ms++)
	{
	$rname = $q->param("rname$ms");
	$remail = $q->param("remail$ms");
	$review = $q->param("review$ms");
	$rvid = $q->param("item$ms");
	
		for ($mse = 1; $mse < 11; $mse++)
		{
		$paramname = "extra" . $mse . "_" . $ms;
		$review = $review . "o-o:o-o" . $q->param($paramname);
		}
		
	
	$sth->bind_param(1, $rname); 			### rname
	$sth->bind_param(2, $remail); 		### remail
	$sth->bind_param(3, $review); 		### review
	$sth->bind_param(4, $rvid); 			### rvid
	
   $sth->execute;
	}

$sth->finish;
$dbh->disconnect;


$popup = $q->param('popup');
if ($popup eq "true")
{

$hbox = acs::get_heading_box("$web_url/ic_comment.gif", "Review/Comment Saved", qq[
You may <a href="javascript:onClick=window.close()">close</a> this window.
]); 

print qq[

<html>
<head>
<title>Reviews</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body onUnload="opener.location.reload(true);">
$hbox
</body>
</html>

];
exit;

}



if ($q->param('notnew') ne "true")
	{

$hbox = acs::get_heading_box("$web_url/ic_comment.gif", "Your changes has been saved.", qq[
Your changes has been saved. <a href="$admin_url/admin14.cgi">Click here to continue</a>
]); 

$EDITcomplete = $EDITcomplete . $hbox;

	}
	else
	{
	$lnkid = $q->param('lnkid');

$hbox = acs::get_heading_box("$web_url/ic_comment.gif", "Your changes has been saved.", qq[
<a href="$admin_url/admin15.cgi?lnkid=$lnkid">Click here to continue</a>
]); 

$EDITcomplete = $EDITcomplete . $hbox;

	}

print <<END_OF_SAVED;

<html>
<head>
<title>Reviews</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$EDITcomplete
</body>
</html>

END_OF_SAVED

}





sub approve_reviews
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = qq{UPDATE links SET rev_no = ? WHERE lnkid = ?};
$sth = $dbh->prepare($sql);
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

$smc = 0;



for ($ms = 0; $ms < $q->param('enr'); $ms++)
	{
	$cname = "C" . $ms;
	if ($q->param($cname) ne "") 
		{
		($rvid, $lnkid, $review_nos) = split (/-/, $q->param($cname));
		$sql_wherer = $sql_wherer . " (rvid = '$rvid') OR";
		$sql_links = $sql_links . " (B.rvid = '$rvid') OR";
		
		$review_nos++;
		
			#### IF THERE ARE 2 LINKS OR MORE OF THE SAME LINKS WITH REVIEWS
			foreach $item (@samelink)
				{
				($lid, $rvn) = split (/:/, $item);
					if ($lnkid == $lid)
						{
						$review_nos++;
						}
				}
			
				$samelink[$smc] = "$lnkid:$review_nos";
				$smc++;
			
		
		$sth->bind_param(1, $review_nos);
		$sth->bind_param(2, $lnkid);
		$sth->execute;
		}
	}

$sql_wherer = substr($sql_wherer, 0, length($sql_wherer) -2);

$sql = "UPDATE reviews SET approved = 'Y' WHERE $sql_wherer";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}


###############################
### SEND NOTIFICATION TO LINK OWNERS OF APPROVAL OF REVIEWS/COMMENTS


$eml_notification_settings = acs::get_file_contents("$data_dir/emlcomnot.dat");
($elmnot, $emladm) = split (/\n/, $eml_notification_settings);


if ($q->param('faction') eq "Approve_EML")
	{

	$email_message_n1 = acs::get_file_contents("$data_dir/emlnot.eml");
	@elines = split (/\n/, $email_message_n1);
	$from_name_n = $elines[0];
	$from_email_n = $elines[1];
	$email_subject_n = $elines[2];
	
	$lnc = 0;
	foreach $line (@elines)
		{
		if ($lnc > 2)
			{
			$email_message_n = $email_message_n . $line . "\n";
			}
		$lnc++;
		}
		

		
		$sql_links = substr($sql_links, 0, length($sql_links) -2);
		
		$rsql = "SELECT A.lnkid, A.cid, A.title, A.description, A.url, A.email FROM links AS A,
																					 reviews AS B
																					 WHERE ($sql_links)
																					 AND (A.lnkid = B.lnkid)";
																					 
			
		$sth = $dbh->prepare($rsql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
		while ( @row = $sth->fetchrow() )
			{
			$cid = "$row[0]";
			$comment_link = "$script_url/reviews.cgi?id=$row[0]&cid=$row[1]";
			$title_without_link = "$row[2]";
			$url = "$row[4]";
			$description = "$row[3]";
			$lemail = "$row[5]";

			$email_message_n =~ s/%%comment_link%%/$comment_link/gi;
			$email_message_n =~ s/!!link_title!!/$title_without_link/gi;
			$email_message_n =~ s/!!link_url!!/$url/gi;
			$email_message_n =~ s/!!link_description!!/$description/gi;
			
			acs::send_email ($from_name_n, $from_email_n, $lemail, $email_subject_n, $email_message_n);  
			}
		
	}






$sth->finish;
$dbh->disconnect;



$hbox = acs::get_heading_box("$web_url/ic_comment.gif", "Comments/Reviews Approved.", qq[
<a href="$admin_url/admin14.cgi">Click Here to Continue</a>
]);

print <<END_OF_RV;

<html>
<head>
<title>Comments/Reviews</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>

END_OF_RV

exit;

}





sub rv_opperations
{

### CHECK IF SOMETHING HAS BEEN SELECTED

for ($ms = 0; $ms < $q->param('enr'); $ms++)
	{
	$cname = "C" . $ms;
	if ($q->param($cname) ne "") { $something_selected = "true"; }
	}

if ($something_selected ne "true"){acs::problem_popup("Nothing was selected."); exit;}

if ($q->param('faction') eq "Edit"){&edit_reviews;}
if ($q->param('faction') eq "Approve"){&approve_reviews;}
if ($q->param('faction') eq "Delete"){&del_reviews;}

if ($q->param('faction') eq "Delete2"){&delete_approved; exit;}


if ($q->param('faction') eq "Approve_EML"){&approve_reviews;}

}






sub delete_approved
{

$RVdeleted = 0;
for ($ms = 0; $ms < $q->param('enr'); $ms++)
	{
	$cname = "C" . $ms;
	if ($q->param($cname) ne "")
		{
		($rvid, $lnkid, $review_nos) = split (/-/, $q->param($cname));
		$sql_where = $sql_where . " (rvid = '$rvid') OR";
		$RVdeleted++;
		}
	}
	
	$sql_where = substr($sql_where, 0, length($sql_where) -2);
	
$sql = "DELETE FROM reviews WHERE $sql_where";

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

#print "==> $sql <Br><BR>";


#### DELETE REVIEWS
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}


#### GET NUMBER OF REVIEWS FOR LINK
$wsql = "SELECT rev_no FROM links WHERE lnkid = '$lnkid'";
$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}

while ( @row = $sth->fetchrow() )
	{
	$lnknr = $row[0];
	}

#print "CURRENT LINKS: $lnknr <br><Br>";

$lnknr = $lnknr - $RVdeleted;

#print "NEW LINKS: $lnknr <Br><BR>";

#### UPDATE NUMBER OF REVIEWS
$wsql = "UPDATE links SET rev_no = '$lnknr' WHERE lnkid = '$lnkid'";
$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}

$sth->finish;
$dbh->disconnect;

$hbox = acs::get_heading_box("$web_url/ic_comment.gif", "Reviews/Comments Removed", qq[
<a href="$admin_url/admin15.cgi?lnkid=$lnkid">Click Here to Continue</a>
]);

print <<END_OF_RV;
<html>
<head>
<title>Reviews</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>

END_OF_RV

}






sub edit_reviews
{

for ($ms = 0; $ms < $q->param('enr'); $ms++)
	{
	$cname = "C" . $ms;
	if ($q->param($cname) ne "") 
		{
		($rvid, $lnkid, $review_nos) = split (/-/, $q->param($cname));
		$sql_where = $sql_where . " (rvid = '$rvid') OR";
		}
	}
	
	$sql_where = substr($sql_where, 0, length($sql_where)-2);
	
$sql = "SELECT * FROM reviews WHERE $sql_where";

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
$rows = $sth->rows();


### EXTRA FIELDS

$ldata = &get_file_contents("$data_dir/keyscom.dat"); 
@allditems = split (/\n/, $ldata);



$itcnt = 0;
while ( @row = $sth->fetchrow() )
	{

	$date = acs::decode_date($row[7]);
	
	$all_extra = $row[5];
	my @extra_items = split (/o-o:o-o/, $all_extra);

	$itemcnt = 1; $extra_details = "";
	foreach $item (@allditems)
		{
		($ename, $echar, $ereq) = split (/\t/, $item);
		
		if ($ename ne "")
			{
			$extra_name = "extra" . $itemcnt . "_" . $itcnt;
			
			if ($echar < 255)
				{
				$extra_details = $extra_details . qq[<tr>
				<td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>$ename: </strong></td>
				<td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="$extra_name" size="51" value="$extra_items[$itemcnt]" style="width:100%"></td>
				</tr>];
				}
				else
				{
				$extra_details = $extra_details . qq[<tr>
				<td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>$ename: </strong></td>
				<td width="72%" bgcolor="#FFFFFF" class="normaltext">
				<textarea rows="5" name="$extra_name" cols="49" style="width:100%">$extra_items[$itemcnt]</textarea>
				</td></tr>];
				}
			
			}
	
		$itemcnt++;
		}
	
	
$edit_box = $edit_box . qq[

<input type="hidden" name="item$itcnt" value="$row[0]">
<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#D8D8D8">
  <tr>
    <td width="29%" valign="top" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Review
    BY: </strong></td>
    <td width="72%" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><input type="text"
    name="rname$itcnt" size="51" 
    value="$row[3]"> Max 255 Chars </td>
  </tr>
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Email: </strong></td>
    <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="remail$itcnt" size="51"
     value="$row[4]"> <br>
    Max 255 Characters </td>
  </tr>
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Comment: </strong></td>
    <td width="72%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="8" name="review$itcnt" cols="49">$extra_items[0]</textarea> </td>
  </tr>
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Date: </strong></td>
    <td width="72%" bgcolor="#FFFFFF" class="normaltext"><strong>$date </strong></td>
  </tr>
  $extra_details
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
    <td width="99%"></td>
  </tr>
</table>
<br>

];

$itcnt++;
	}



$sth->finish;
$dbh->disconnect;


if ($q->param('notnew') ne "true")
	{
	$PHtext = "Approve New Reviews &gt;&gt; Edit New Reviews";
	}
	else
	{
	$PHtext = "Edit Reviews";
	$PHhv = "<input type=\"hidden\" name=\"notnew\" value=\"true\"><input type=\"hidden\" name=\"lnkid\" value=\"$lnkid\">";
	}

$popup = $q->param('popup');



$hbox = acs::get_heading_box("$web_url/ic_comment.gif", "$PHtext", qq[
]);


print <<END_OF_EDN;

<html>
<head>
<title>Reviews</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
<form method="POST" action="$admin_url/admin14.cgi">
  <input type="hidden" name="fct" value="save_reviews">
  <input type="hidden" name="enr" value="$itcnt">
  <input type="hidden" name="popup" value="$popup">
  $PHhv

$hbox

$edit_box
<input type="submit" value="   Save   " name="B1">

</body>
</html>

END_OF_EDN

}





##################################################################################

sub start
{


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }



#### CHECK FOR DEAD LINKS
#
#$sth = $dbh->prepare("SELECT COUNT(*) FROM reviews WHERE approved = 'Y'");
#$sth->execute;
#$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
#while ( @row = $sth->fetchrow() ){$reviews_rows = $row[0];}
#
####
											 ## ROW 8
$sth = $dbh->prepare("SELECT A.*, B.title, B.description, B.url, B.rev_no, C.l1, C.l2, C.l3, C.l4, C.l5, C.l6, C.l7, C.l8, C.l9, C.l10, C.l11, C.l12, C.l13, C.l14, C.l15, C.l16
										FROM 
										reviews AS A,
										links AS B,
										dirs AS C
										WHERE 
										(A.approved = 'N')
										AND
										(A.cid = C.cid)
										AND
										(A.lnkid = B.lnkid)
										");



if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows();

$rvapp = qq[<span class="normaltext">];

########

$gsettings = new_gsettings acs; 

$csearchres = $gsettings->{comments_nr}; if ($csearchres eq "") { $csearchres = 20; } 

$icnt = $rows;
$nr_searchres = $csearchres;

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$ippc = 1;

######## EXTRA FIELD DETAILS

$ldata = &get_file_contents("$data_dir/keyscom.dat"); 
@allditems = split (/\n/, $ldata);

########


$vlc = 0;
while ( @row = $sth->fetchrow() )
	{

if (($ippc > $st) and ($ippc <= $nd))
    {		

 	$cats = ""; $ecat = "";
 	for ($ms = 13; $ms < 29; $ms++)
 		{
 		if ($row[$ms] ne "")
 			{
 			$ecat = $ecat . acs::encode_dir($row[$ms]) . "-";
 			$cats = $cats . $row[$ms] . "/";
 			}
		}
		
		$ecat = substr($ecat, 0, length($ecat) - 1);
		
		$date = acs::decode_date($row[7]);

		$checkbname = "C" . $vlc;

		$checkbname_js = "'C" . $vlc ."'";
		$selall = $selall . $checkbname_js . ",";
		
		if ($row[11] eq "") { $row[11] = 0; }
		
		$row[5] =~ s/\n/<BR>/gi;


### EXTRA FIELDS

$all_extra = $row[5];

my @extra_items = split (/o-o:o-o/, $all_extra);

$itemcnt = 1;
foreach $item (@allditems)
	{
	($ename, $echar, $ereq) = split (/\t/, $item);
	
	if ($ename ne "")
		{
		$field_to_display = $extra_items[$itemcnt]; $field_to_display =~ s/\n/<BR>/g;
		$extra_items[$itemcnt] = "<BR><b>$ename:</b> " . $field_to_display . "<BR>";
		}
	
	$itemcnt++;
	}



$rvapp = $rvapp . <<END_OF_RVA;

<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(221,221,221)">
  <tr>
    <td width="1%" valign="top" background="$web_url/bar6.gif"></td>
    <td width="50%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Comment/Review
    Posted:</strong></td>
    <td width="49%" valign="top" background="$web_url/bar6.gif" class="normaltext"
    style="border-left: 1px solid rgb(233,233,233)"><strong>For Listing:</strong></td>
  </tr>
  <tr>
    <td width="1%" valign="top"><strong><input type="checkbox" name="$checkbname"
    value="$row[0]-$row[2]-$row[11]"> </strong></td>
    <td width="50%" valign="top" class="normaltext"><strong>$ippc. By: </strong>$row[3] <br>
    <strong>Review/Comment: </strong><br>
    <br>
    $extra_items[0]<br>
    
    $extra_items[1] $extra_items[2] $extra_items[3] $extra_items[4] $extra_items[5] $extra_items[6] $extra_items[7] $extra_items[8] $extra_items[9] $extra_items[10]
    
    <br>
    <strong>Date: </strong>$date <br>
    <strong>Email: </strong>$row[4] <br>
    [ <strong><a
    href="$admin_url/admin14.cgi?faction=Approve&amp;C0=$row[0]-$row[2]-$row[11]&amp;enr=1&amp;fct=ropps">Approve
    </a></strong>] [ <strong><a
    href="$admin_url/admin14.cgi?faction=Edit&amp;C0=$row[0]-$row[2]-$row[11]&amp;enr=1&amp;fct=ropps"
    onClick="popup('$admin_url/admin14.cgi?faction=Edit&amp;C0=$row[0]-$row[2]-$row[11]&amp;enr=1&amp;fct=ropps&amp;popup=true',600,600);return false;">Edit
    </a></strong>] [ <strong><a
    href="$admin_url/admin14.cgi?faction=Delete&amp;C0=$row[0]-$row[2]-$row[11]&amp;enr=1&amp;fct=ropps">Delete
    </a></strong>] </td>
    <td width="49%" valign="top" class="normaltext"
    style="border-left: 1px solid rgb(233,233,233)"><strong><a href="$row[11]" target="_blank">$row[9]
    </a></strong><br>
    $row[10] <br>
    <strong>From: <a href="$admin_url/admin12.cgi?ct=$ecat&amp;fct=gotocat&amp;cid=$row[1]"
    onClick="self.opener.location='$admin_url/admin12.cgi?ct=$ecat&amp;fct=gotocat&amp;cid=$row[1]'; self.opener.focus(); return false;">$cats
    </a></strong><br>
    <strong>LinkID: </strong><a
    href="$admin_url/admin12.cgi?ct=$ecat&amp;fct=Edit&amp;cid=$row[1]&amp;C0=$row[0]"
    onClick="popup('$admin_url/admin12.cgi?ct=$ecat&amp;fct=Edit&amp;cid=$row[1]&amp;C0=$row[2]',600,600);return false;">$row[2]
    </a></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>

END_OF_RVA

	$vlc++;	
	}
$ippc++;
}

$selall = substr($selall, 0, length($selall) - 1);

$sth->finish;
$dbh->disconnect;



#### PAGES

for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " [$pg] ";
		$targpage = $pg;
		}
	  	else
		{
		$st1 = ($pg * $nr_searchres) - $nr_searchres;
		$nd1 = ($pg * $nr_searchres);
		$pgstring = $pgstring . "<a href=\"$admin_url/admin14.cgi?st=$st1&nd=$nd1\">$pg</a> ";
		}
	}

if ($pages > 1)
	{
	$pgstring = "Pages: " . $pgstring;
	}
	else
	{
	$pgstring = "";
	}


### NEXT / PREV PAGES


$spls = $modp;
if ($spls == 0){$spls++;}

 if ($nd <= ($icnt - $spls))
 	{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = "<a href=\"$admin_url/admin14.cgi?st=$st1&nd=$nd1\">Next Page >></a> ";
	}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = "<a href=\"$admin_url/admin14.cgi?st=$st1&nd=$nd1\"><< Prev Page</a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " | ";
	}
	else
	{
	$spcer = " ";
	}
	  
	$prevnext = $prev . "$spcer" . $nextt;

	if (length($prevnext) > 5){$myspacer = " | ";}

	

if ($pages > 1)
	{
	$prevnext = "$prevnext $myspacer Page $targpage of $pg";
	}
	else
	{
	$prevnext = "";
	}

##############

if ($vlc > 0)
	{

$pgbott = <<END_OF_PGB;
<img src="$web_url/dbut2.gif">
<select name="faction" size="1">
<option value="Approve">Approve Selected Reviews</option>
<option value="Approve_EML">Approve Selected Reviews and Send Link Owners Email About Comments/Reviews</option>
<option value="Delete">Delete Selected Reviews</option>
<option value="Edit">Edit Selected Reviews</option>
</select>
<input type="submit" value="Submit" name="B1"></p>

<span class="normaltext">
<a href="javascript:checkall('select_all',true)">Check All</a> | 
<a href="javascript:checkall('select_all',false)">UnCheck All</a>
</span>

<input type="hidden" name="nr_links" value="12">

<table border="0" cellpadding="6" cellspacing="1" width="100%">
  <tr>
    <td width="50%" class="normaltext">$prevnext</td>
    <td width="50%" align="right" class="normaltext">$pgstring</td>
  </tr>
</table>
</form>

END_OF_PGB

	}
	else
	{
	$pgbott = "<b>There are currently no new reviews that need to be approved</b>";
	}	
	
	
$hbox = acs::get_heading_box("$web_url/ic_comment.gif", "Approve New Comments/Reviews", qq[
There are currently $rows reviews that needs approval.
]);  


print <<END_OF_RVA;

<html>
<head>
<title>Reviews</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
<script LANGUAGE="JavaScript">
<!-- Hide

function checkall(formname,thestate)
	{
	BoxNames=new Array($selall);
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}

 function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(100,40);
      myWindow.focus();

    }

// End Hide -->
</script>



</head>
<body>

$hbox

<form method="POST" name="select_all" action="$admin_url/admin14.cgi">
  <input type="hidden" name="fct" value="ropps"><input type="hidden" name="enr" value="$vlc"><p>$rvapp
  $pgbott </p>
</form>

<form method="POST" action="$admin_url/admin14.cgi">
  <input type="hidden" name="fct" value="set_results"><p><strong>How
  many results to list on a per page basis:</strong> <select name="results" size="1">
    <option value="10">10</option>
    <option value="20">20</option>
    <option value="30">30</option>
    <option value="50">50</option>
    <option value="100">100</option>
    <option value="200">200</option>
    <option value="400">400</option>
    <option value="500">500</option>
    <option value="1000">1000</option>
  </select> <input type="submit" value="   Go   " name="B1"></p>
</form>


<ul class="normaltext">
  <li><strong><a href="admin10.cgi?fct=global_settings#6"
    onClick="popup('admin10.cgi?fct=global_settings#6',750,550);return false;">Comment/Review
    Settings </a></strong></li>
  <li><strong><a href="$admin_url/admin75.cgi"
    onClick="popup('$admin_url/admin75.cgi',750,550);return false;">Comment/Review Email
    Notification Settings </a></strong></li>
</ul>


</body>
</html>

END_OF_RVA



}

####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

